From mooneer@earthlink.net  Fri Jul 16 23:54:47 1999
Return-Path: <mooneer@earthlink.net>
Received: from hawk.prod.itd.earthlink.net (hawk.prod.itd.earthlink.net [207.217.120.22])
	by atrey.karlin.mff.cuni.cz (8.8.8/8.8.8) with ESMTP id XAA08101
	for <pavel@atrey.karlin.mff.cuni.cz>; Fri, 16 Jul 1999 23:54:47 +0200
Received: from earthlink.net (pool0560.cvx10-bradley.dialup.earthlink.net [209.178.184.50])
	by hawk.prod.itd.earthlink.net (8.9.3/8.9.3) with ESMTP id OAA01029
	for <pavel@atrey.karlin.mff.cuni.cz>; Fri, 16 Jul 1999 14:54:39 -0700 (PDT)
Message-ID: <378FAA1F.A6547D86@earthlink.net>
Date: Fri, 16 Jul 1999 14:54:39 -0700
From: Mooneer Salem <mooneer@earthlink.net>
Organization: HyperNetMsg
X-Mailer: Mozilla 4.5 [en] (Win98; I)
X-Accept-Language: en
MIME-Version: 1.0
To: pavel@atrey.karlin.mff.cuni.cz
Subject: Network Block Device server port (Attachment)
Content-Type: multipart/mixed;
 boundary="------------2ABB914B08E943632AA7DD4F"
Status: RO
Content-Length: 4819
Lines: 177

This is a multi-part message in MIME format.
--------------2ABB914B08E943632AA7DD4F
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: 7bit

 
--------------2ABB914B08E943632AA7DD4F
Content-Type: text/plain; charset=us-ascii;
 name="nbd-server.c"
Content-Transfer-Encoding: 7bit
Content-Disposition: inline;
 filename="nbd-server.c"

/* nbd server for Win32
   By Mooneer Salem (mooneer@earthlink.net)

   Disclaimer: This is alpha software. I'm not responsible for
     any data loss as a result of using this program. Until it
     becomes more stable, please use caution. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>
#include <ctype.h>
#include <errno.h>
#include <signal.h>
#include <fcntl.h>

#define err_std(err_text) fprintf(stderr, err_text)

struct packet_req {
   int magic, from, length;
   char handle[8];
   int type;
};

struct packet_resp {
   int magic;
   char handle[8];
   int error;
};

int main(int argc, char *argv[])
{
    int sockfd, new_fd;  /* listen on sock_fd, new connection on new_fd */
    struct sockaddr_in my_addr;    /* my address information */
    struct sockaddr_in their_addr; /* connector's address information */
    int sin_size;
    long filelen;
    unsigned long j;
    FILE *fp;
    char *buf;
    struct packet_req request;
    struct packet_resp response;

    if (argc < 4) {
        err_std("Usage: nbd-server [port] [filename] [ro]\n");
        exit(1);
    }

    if (!strncmp("ro", argv[3], 2)) {
        fp = fopen(argv[1], "rb");
    } else {
        fp = fopen(argv[1], "r+b");
    }

    if (!fp) {
       err_std("Umm...cannot open the file.\n");
       exit(1);
    }

    filelen = fseek(fp, 0, SEEK_END);
    if (filelen == -1) {
       err_std("Could not determine file size.\n");
       exit(1);
    }

    /* Needed for non-Unix platforms */
    _setmode(fileno(fp), O_BINARY);
    
    if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
        perror("socket");
        exit(1);
    }

    my_addr.sin_family = AF_INET;         /* host byte order */
    my_addr.sin_port = htons(atoi(argv[1]));     /* short, network byte order */
    my_addr.sin_addr.s_addr = INADDR_ANY; /* auto-fill with my IP */
    bzero(my_addr.sin_zero, 8);        /* zero the rest of the struct */

    if (bind(sockfd, (struct sockaddr *)&my_addr, sizeof(struct sockaddr)) == -1) {
        perror("bind");
        exit(1);
    }

    if (listen(sockfd, 1) == -1) {
        perror("listen");
        exit(1);
    }

    sin_size = sizeof(struct sockaddr_in);
    if ((new_fd = accept(sockfd, (struct sockaddr *)&their_addr, &sin_size)) == -1) {
        perror("accept");
        exit(1);
    }
    printf("server: got connection from %s\n", inet_ntoa(their_addr.sin_addr));
        
    /* Neogiate the NBD connection */
    write(new_fd, "MAGICNBD", 8);
    j = htonl(0x81861253);
    write(new_fd, &j, sizeof(j));
    j = htonl(filelen);
    write(new_fd, &j, sizeof(j));

    while(1) {
       read(new_fd, &request, sizeof(request));
       request.length = ntohl(request.length);
       request.from = ntohl( request.from );
       request.magic = ntohl( request.magic );
       request.type = ntohl( request.type );

       if (request.magic != 0x25609513) {
          err_std("Invalid command type.");
          exit(1);
       }

       response.error = 0;

       if ((request.from + request.length) > filelen) {
          response.error = 1;
       } else if (request.from < 0) {
          response.error = 1;
       } else if ((request.type == 1) && (!strncmp("ro", argv[3], 2))) {
          response.error = 1;
       }

       response.magic = 0x67446698;
       memcpy( response.handle, request.handle, sizeof( response.handle ));
       
       if ((request.type == 0) && (!response.error)) {
          fseek(fp, request.from, SEEK_SET);
          buf = calloc(request.length, 1);
          if (!buf) {
             err_std("Out of memory!");
             exit(1);
          }
          fread(buf, 1, request.length, fp);
          fflush(fp);
       } else if ((request.type == 1) && (!response.error)) {
          fseek(fp, request.from, SEEK_SET);
          buf = calloc(request.length, 1);
          if (!buf) {
             err_std("Out of memory!");
             exit(1);
          }
          read(new_fd, &buf, request.length);
          fwrite(&buf, 1, request.length, fp);
          fflush(fp);
       }

       write(new_fd, &response, sizeof(response));
       if ((request.type == 0) && (!response.error)) {
          write(new_fd, &buf, request.length);
       }
 
       free(buf);
   }
 }
--------------2ABB914B08E943632AA7DD4F--

